package com.jy.system.service.impl;

import cn.hutool.core.util.ArrayUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.toolkit.StringPool;
import com.jy.framework.model.base.BaseIdPo;
import com.jy.framework.model.constants.CommonConstant;
import com.jy.framework.model.constants.MenuConstant;
import com.jy.framework.utils.AssertUtil;
import com.jy.framework.utils.tree.TreeUtil;
import com.jy.system.dao.SysMenuDao;
import com.jy.system.model.dto.SysMenuDto;
import com.jy.system.model.dto.SysMenuSelectDto;
import com.jy.system.model.entity.SysMenu;
import com.jy.system.model.entity.SysRole;
import com.jy.system.model.vo.SysMenuVo;
import com.jy.system.service.SysMenuService;
import jakarta.annotation.Resource;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

/**
 * <p>
 * 菜单 服务实现类
 * </p>
 *
 * @author
 * @since 2024-06-20
 */
@Service
public class SysMenuServiceImpl implements SysMenuService {

    @Resource
    private SysMenuDao sysMenuDao;

    @Override
    public List<SysMenuVo> getTree(SysMenuSelectDto dto) {
        List<SysMenuVo> list = sysMenuDao.getList(dto);
        return TreeUtil.build(list);
    }

    @Override
    public SysMenuVo getDetail(Long id) {
        SysMenuVo vo = sysMenuDao.getDetail(id);
        AssertUtil.notNull(vo, "未知数据");
        vo.setPermArray(StrUtil.isBlank(vo.getPerms()) ? new String[]{} : vo.getPerms().split(StringPool.COMMA));
        return vo;
    }

    @Override
    public void add(SysMenuDto dto) {
        // 验证同级菜单是否存在
        boolean exists = sysMenuDao.peerTitleExists(dto.getParentId(), dto.getTitle());
        AssertUtil.eqFalse(exists, "同级菜单名称已存在");

        // 字段去除前后空格
        fieldTrim(dto);

        // 赋值权限标识
        dto.setPerms(ArrayUtil.isEmpty(dto.getPermArray()) ?
                StringPool.EMPTY : String.join(StringPool.COMMA, dto.getPermArray()));

        // 保存
        sysMenuDao.save(dto);
    }

    @Override
    public void edit(SysMenuDto dto) {
        // 验证同级菜单是否存在
        boolean exists = sysMenuDao.peerTitleExists(dto.getParentId(), dto.getTitle(), dto.getId());
        AssertUtil.eqFalse(exists, "同级菜单名称已存在");

        // 字段去除前后空格
        fieldTrim(dto);

        // 赋值权限标识
        dto.setPerms(ArrayUtil.isEmpty(dto.getPermArray()) ?
                StringPool.EMPTY : String.join(StringPool.COMMA, dto.getPermArray()));

        // 编辑
        sysMenuDao.updateById(dto);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(Long id) {
        SysMenu menu = sysMenuDao.getById(id);
        AssertUtil.notNull(menu, "菜单不存在");

        // 如果是目录，存在子菜单拒绝删除
        if (MenuConstant.DIRECTORY.equals(menu.getType())) {
            boolean exists = sysMenuDao.childrenExists(id);
            AssertUtil.eqFalse(exists, "存在子菜单，无法删除");
        }

        // 如果是菜单，删除底下的按钮
        if (MenuConstant.MENU.equals(menu.getType())) {
            sysMenuDao.removeByParentId(id);
        }

        // 删除
        sysMenuDao.removeById(id);
    }

    @Override
    public List<SysMenuVo> getUserEnableList(Long userId, List<SysRole> sysRoleList) {
        // 超级管理员获取全部启用菜单
        if (CommonConstant.SUPER_ADMIN_USER_ID.equals(userId)) {
            return sysMenuDao.getEnableList();
        }

        // 未绑定角色无法获取菜单
        if (sysRoleList.isEmpty()) {
            return Collections.emptyList();
        }

        // 查询角色关联菜单
        Set<Long> sysRoleIdSet = sysRoleList.stream().map(BaseIdPo::getId).collect(Collectors.toSet());
        return sysMenuDao.getEnableListByRoleIds(sysRoleIdSet);
    }

    /**
     * 字段去除前后空格
     *
     * @param menu 菜单实体
     */
    private void fieldTrim(SysMenu menu) {
        if (StrUtil.isNotBlank(menu.getTitle())) {
            menu.setTitle(menu.getTitle().trim());
        }
        if (StrUtil.isNotBlank(menu.getName())) {
            menu.setName(menu.getName().trim());
        }
        if (StrUtil.isNotBlank(menu.getPath())) {
            menu.setPath(menu.getPath().trim());
        }
    }

}
